#! /bin/sh


RECMKDIR=../recmkdir 

INSTALL_DIR=$1
FONTDEF=$2
FONTS_FILE=$3
SRC_TFM_Y=$4
SRC_TFM_T=$5



DUP=`sed 's/#.*//' ${FONTDEF} \
       | grep -v '^[ 	]*$$' \
       | awk '{print $$3}' | sort | uniq -d`
if [ ! -z "$DUP" ] ; then
  echo "Duplicated font definition!" $DUP >&2
  exit
fi


if [ ! -f ${FONTS_FILE} ] ; then
  echo ""
  echo "No such file:" ${FONTS_FILE} >&2;
  echo ""
  exit 0;
fi


### KPSEWHICH 
which kpsewhich >/dev/null 2>&1 /dev/null
if [ $? = 1 ] ; then
  echo "Not found: kpsewhich" >&2;
  exit 0;
fi

### TFM_Y
SRC_TFM_Y=`kpsewhich ${SRC_TFM_Y}`
if [ -z "${SRC_TFM_Y}" -o ! -f "${SRC_TFM_Y}" ] ; then
  echo "Not found: ${SRC_TFM_Y}" >&2;
  exit 0;
fi

### TFM_T
SRC_TFM_T=`kpsewhich ${SRC_TFM_T}`
if [ -z "${SRC_TFM_T}" -o ! -f "${SRC_TFM_T}" ] ; then
  echo "Not found: ${SRC_TFM_T}" >&2;
  exit 0;
fi



###

FONT_LIST=`awk '{ print $1 }' ${FONTS_FILE}`

if test ! -f ${INSTALL_DIR}/tfm; then
  ${RECMKDIR}  ${INSTALL_DIR}/tfm
fi

cd ${INSTALL_DIR}/tfm
for F in ${FONT_LIST}
do
  #echo "$F.tfm t$F.tfm ..."
  rm -f $F.tfm t$F.tfm
  cp ${SRC_TFM_Y} $F.tfm
  cp ${SRC_TFM_T} t$F.tfm
     # "ln -s" should not be used, since files does not appear in "ls-R".
done

echo "***"
echo "*** You must run 'mktexlsr' program "
echo "*** to update the 'ls-R' file (database for TeX-related files)."
echo "***"

#EOF
